# Решения

Исправьте проблемы настройки сети в виртуальных машинах `troublesome-X-task[1-5]`. В каждой машине 1 проблема после исправления которой работает команда `ping yandex.com`. Шлюз по умолчанию для машины в каждом задании - 192.168.1.1 в сети 192.168.1.0/24. Всего 5 заданий. Используйте механизм снимков и команду rollback в proxmox интерфейсе, чтобы откатывать машину в первоначальное состояние. 

### 1. Не активирован и не запущен systemd-networkd
```
sudo systemctl enable systemd-networkd
sudo systemctl start systemd-networkd
```

### 2. В настройках не указан шлюз по умолчанию
```
sudo "echo Gateway=192.168.1.1 >> /etc/systemd/network/ens18.network"
sudo networkctl reload
```

### 3. В настройках systemd-resolved не указан DNS
```
sudo "echo DNS=1.1.1.1 >> /etc/systemd/resolved.conf"
sudo systemctl restart systemd-resolved
```

### 4. Машина находится в другой сети по отношению к шлюзу
```
sudo sed 's/172\.16/192\.168/' -i /etc/systemd/network/ens18.network
sudo networkctl reload
```

### 5. На сетевом интерфейсе установлен MAC-дубликат шлюза 
Установите родной mac `permaddr`:
```
sudo "ip link set address $(ip link show ens18 | grep permaddr | awk '{ print $6 }') dev ens18"
```

### 6. Неверные права папки .ssh пользователя mike

В 6ом задании `troublesome-X-task6` вам требуется отладить команду `ssh localhost -l mike`, запущенную от пользователя stud. Команда должна отработать без ввода пароля.

```
sudo chmod 0700 /home/mike/.ssh
```

Также желательно исправить группу-владельца:
```
sudo chown mike:mike /home/mike/.ssh
```